import * as messaging from "messaging";
import { settingsStorage } from "settings";

//console.log("Companion Started");

messaging.peerSocket.onopen = () => {
};

messaging.peerSocket.close = () => {
};

settingsStorage.onchange = evt => {
  let data = {}
  switch(evt.key) {
    case 'digitColor':
    case 'ornamentColor':
      data = {
        key: evt.key,
        newValue: JSON.parse(evt.newValue).values[0].value
      };
      break;
    case 'elements':
      let elements = [];
      let newValue = JSON.parse(evt.newValue);
      for(let i=0; i < newValue.length; i++) {
        elements[i] = newValue[i].value;
      }
      data = {
        key: evt.key,
        newValue: elements
      };
    default:
      data = {
        key: evt.key,
        newValue: evt.newValue
      };
      break;
  }
  
  sendVal(data);
};

function sendVal(data) {
  if (messaging.peerSocket.readyState === messaging.peerSocket.OPEN) {
    messaging.peerSocket.send(data);
  }
}